package model;

public class Person {
	/*
	 * Attributes:
	 * 	+ Shared by all instances of Person.
	 * 	+ Each instance of Person might have different values for their attributes.
	 */
	private double weight; /* in kg */
	private double height; /* in m */
	
	public Person() {
		
	}
	
	/*
	 * When no constructors are declared here,
	 * the default constructor will be available (implicitly).
	 */
	public Person(double weight, double height) {
		this.weight = weight; /* Why: newWeight = weight not working?*/
		this.height = height;
	}
	
	/*
	 * Accessor/Getter
	 */
	public double getBMI() {
		double result;
		
		/*
		 * This would be an error because
		 * result must be initialized before its frist use.
		 */
//		double d = result * 2;
		
		/*
		 * Removing `this.` here will still work.
		 * Because there's no variable shadowing. 
		 */
		result = this.weight / (this.height * this.height);
		
		return result;
	}
	
	public void gainWeightBy(double amount) {
		this.weight += amount;
	}
	
	/*
	 * Without redefining/overridding the toString method,
	 * by default, it returns the object's address.
	 */
//	public String toString() {
//		/*
//		 * Rather than returning the address,
//		 * return something that's more meaningful.
//		 */
//		String result = "Weight " + this.weight;
//		
//		return result;
//	}
	
}












